package me.unurled.sacredrealms.sr.components.entity;

import java.util.HashMap;
import java.util.UUID;
import me.unurled.sacredrealms.sr.managers.Manager;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Mob;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.EntitySpawnEvent;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

public class EntityManager extends Manager {

  @NotNull private final HashMap<UUID, SREntity> entities;

  public EntityManager() {
    super();
    entities = new HashMap<>();
  }

  @Nullable
  public SREntity getEntity(@NotNull UUID uuid) {
    return entities.get(uuid);
  }

  public void addEntity(@NotNull SREntity entity) {
    entities.put(entity.getUuid(), entity);
  }

  public void addEntity(@NotNull Entity e) {
    entities.put(e.getUniqueId(), new SREntity(e));
  }

  public boolean isSREntity(@NotNull UUID uuid) {
    return entities.containsKey(uuid);
  }

  @EventHandler
  public void onEntitySpawn(@NotNull EntitySpawnEvent e) {
    if (e.getEntity() instanceof Player) return;

    if (isSREntity(e.getEntity().getUniqueId())) return;

    if (!(e.getEntity() instanceof Mob)) return;

    e.setCancelled(true);
  }
}
